
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

{-

procedure product2(x0, y0):
	s = x0
	y = 1. / y0
	while (y != 1):
		s = s + x0
		y = y / (1 - y)
	product = s

-}

-- | Program variables
s, s', x0, x0', y0, y0', y' :: (Eq t, Num t) => Polynomial t
s   = var "s"
s'  = var "'s"
x0  = var "x0"
x0' = var "'x0"
y0  = var "y0"
y0' = var "'y0"
y'  = var "'y"

-- | Initial state, exit and post condition, and transitions
init = ideal [ s - x0, y * y0 - 1 ]
exit = ideal [ y - 1 ]
transitions = [ideal [s' - s - x0, y' * (1 - y) - y, x0' - x0, y0' - y0]]

main = dosynthesis (1 - y) init exit 0 transitions [] d ["s", "x0", "y", "y0"]
       where d = 3
