
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

{-

procedure product2(x0, y0):
	s = x0
	y = 1. / y0
	while (y != 1):
		s = s + x0
		y = y / (1 - y)
	product = s

-}

-- | Program variables
s, s', x0, x0', y0, y0', y', c :: (Eq t, Num t) => Polynomial t
s   = var "s"
s'  = var "'s"
x0  = var "x0"
x0' = var "'x0"
y0  = var "y0"
y0' = var "'y0"
y'  = var "'y"
c   = var "c"

-- | Initial state, exit and post condition, and transitions
init = ideal [ s - x0, y * y0 - 1 ]
exit = ideal [ y - 1 ]
post = ideal [ s - x0*y0 ]
transitions = [ideal [y' * (1 - y) - y,
	s' - template "syn1" 1 ["s", "x0", "y", "y0"], x0' - x0, y0' - y0]]

main = dosynthesis (y - 1) init exit post transitions [] d ["s", "x0", "y", "y0"]
       where d = 3
