
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

{-

procedure product(x0, y0):
    s = 0
    y = y0
    while (y != 0):
        s = ??
        y = ??
    assert(s == x0*y0)
assert(product(1, 1) == 1) # one loop iteration
assert(product(3, 2) == 6) # two loop iterations

-}

-- | Program variables
s, s', x0, x0', y0, y0', y' :: (Eq t, Num t) => Polynomial t
s   = var "s"
s'  = var "'s"
x0  = var "x0"
x0' = var "'x0"
y0  = var "y0"
y0' = var "'y0"
y'  = var "'y"

-- | Initial state, exit and post condition, and transitions
init = ideal [ s - 0, y - y0 ]
exit = ideal [ y - 0 ]
post = ideal [ s - x0*y0 ]
transitions = [ideal [y' - template "syn2" 1 ["y"],
                      s' - template "syn1" 1 ["x0", "s", "y", "y0"],
                      x0' - x0,
                      y0' - y0]]

tc_pre, tc_post :: K -> K -> Variable -> K
tc_pre _  _  "s"  = 0
tc_pre x0 _  "x0" = x0
tc_pre _  y0 "y0" = y0
tc_pre _  y0 "y"  = y0
tc_post x0 y0 "s"  = x0*y0
tc_post x0 _  "x0" = x0
tc_post _  y0 "y0" = y0
tc_post _  _  "y"  = 0

testcases = map (\(x,y,i) -> (tc_pre x y, tc_post x y, replicate i $ head transitions))
            [(3, 1, 1), (3, 2, 2)]

main = dosynthesis 1 init exit post transitions testcases d ["s", "x0", "y", "y0"]
       where d = 2 -- degree of the template polynomial for the invariant
