
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

{-

def root2(n):
	"""calculates the closest integer square root of n"""
	p = 0
	q = 1
	r = n
	while q <= n:
		q = q * 4
	while q != 1:
		assert(q*n - p*p - q*r)
		q = q / 4
		h = p + q
		p = p / 2
		if r >= h:
			p = p + q
			r = r - h
	assert(n == p*p + r)
	return (p, r)

-}

-- | Program variables
p, p', q, q', r, r', n, n' :: (Eq t, Num t) => Polynomial t
p  = var "p"
p' = var "'p"
q  = var "q"
q' = var "'q"
r  = var "r"
r' = var "'r"
n  = var "n"
n' = var "'n"

-- | Initial state, exit and post condition, and transitions
init = ideal [ p - 0, r - n ]
exit = ideal [ q - 1 ]
t1 = ideal [ 4*q' - q, 2*p' - p, r' - r, n' - n ]
t2 = ideal [ 4*q' - q, 4*p' - 2*p - q, 4*r' - 4*r + 4*p + q, n' - n]
transitions = [t1, t2]

main = dosynthesis 1 init exit 0 transitions [] d ["p", "q", "r", "n"]
       where d = 2
