#!/bin/bash
sourcedir="`dirname $0`/examples"
smt2dir="`dirname $0`/smt2"
resultdir="`dirname $0`/models"

z3bin="z3"
tmpfile="tmp.smt2"
timefile="time.tmp"
resultfile="result.tmp"
benchmarkfile="benchmark.txt"

mkdir "$smt2dir" 2>/dev/null
mkdir "$resultdir" 2>/dev/null

z3version=`"$z3bin" -version`
echo "Using $z3version" 
date > "$benchmarkfile"
echo "$z3version" >> "$benchmarkfile"
echo >> "$benchmarkfile"

for ex in `find "$sourcedir/" -type f -executable -print`; do
	echo
	date
	echo "======================================"
	exname=`basename "$ex"`
	echo "Example: $exname"
	echo
	echo -n "Computing Synthesis Condition: "
	TIME="%U" time -o "$timefile" "$ex" > "$tmpfile"
	sc_time=`cat "$timefile"`
	echo "$sc_time"s
	cp "$tmpfile" "$smt2dir/$exname.smt2"
	echo -n "Solving: "
	TIME="%U" time -o "$timefile" "$z3bin" -rs:42 "$tmpfile" > "$resultfile"
	z3_time=`cat "$timefile"`
	echo "$z3_time"s
	cp "$resultfile" "$resultdir/$exname.model"
	if [ `cat "$resultfile" | grep -c "model"` == 0 ]; then
		echo "Warning: no model produced!"
	fi
	echo
	
	echo "$exname	$sc_time	$z3_time" >> "$benchmarkfile"
done
rm "$timefile"
